KERNEL(7)

NAME
kernel - operating system kernel

SYNOPSIS
/boot/sortix.bin [--disable-em] [--enable-em] [--disable-network-drivers] [--enable-network-drivers] [--no-random-seed] [--] [init ...]

DESCRIPTION
/boot/sortix.bin is the operating system kernel. It initializes and manages the hardware to provide a multitasking computing environment. The kernel is a multiboot(7) compatible executable loaded by the bootloader along with a companion initrd(7) that contains a userland.

The kernel extracts the initrd into the initial kernel memory root filesystem. The specified init program is invoked with the given arguments, defaulting to the init(8) at /sbin/init if init is not specified. If the init is to receive any argument starting with a dash, first pass the -- delimiter to stop kernel option parsing. The computer is powered off if the init process exits 0, rebooted if it exits 1, halted with an complaint about an init fatality if it exits 2, and halted with a complaint about an unexpected exit code otherwise.

The options are as follows:

--disable-em
    Don't initialize the em(4) driver.

--disable-network-drivers
    Don't initialize any network drivers. This option ensures the booted system is not networked.

--enable-em
    Do initialize the em(4) driver.

--enable-network-drivers
    Do initialize network drivers. This is the default behavior.

--no-random-seed
    Don't warn if no random seed file was loaded by the bootloader (usually from /boot/random.seed). This option is useful for live environments where this situation is unavoidable.

The kernel accepts multiboot modules from the bootloader, which are processed in order. The initrd(7) must be passed through this mechanism.

The format of each multiboot module is automatically detected by default:

•   tar(7) archives in the ustar format are extracted into the root directory. The bootloader must already have decompressed the archive.

Each multiboot module has its own command line where the options are as follows:

--append-to=file
    Append the contents of the module to the specifed file, creating it with mode 644 if it doesn't exist. Non-existent parent directories are created with mode 755 as needed.

--create-to=file
    Create the specified file with mode 644 with contents of the module, but only if it doesn't already exist. No action is taken if the file already existed. Non-existent parent directories are created with mode 755 as needed.

--random-seed
    The module contains random data used to seed the kernel entropy gathering. This file is supposed to contain 256 bytes of secret randomness that hasn't been used before. Recycling the random seed is dangerous and insecure. Omitting the random seed will cause the kernel entropy to be insecurely seeded with the current time and other readily available information. The bootloader normally loads the random seed from /boot/random.seed.

--tar
    The module is a tar(7) archive that is extracted into the root directory.

--tix
    The module is a tix(7) binary package that is installed into the root directory.

--to=file
    Write the contents of the module to the specifed file, creating it with mode 644 if it doesn't exist, and truncating it if it does exist. Non-existent parent directories are created with mode 755 as needed.

SEE ALSO
initrd(7), init(8)